﻿using Infragistics.Windows.DataPresenter;
using MahApps.Metro.Controls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TestHdadmProject
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : MetroWindow
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new MainViewModel();
        }

        private void CallListGrid_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            FieldLayout layout = e.FieldLayout;
            layout.Fields.Clear();
            var ViewModel = (this.DataContext as MainViewModel).Calls;

            //  basefield.CellValuePresenterStyle
            for (int i = 0; i < ViewModel.FirstOrDefault().Fields.Count; i++)
            {
                var firstlist = ViewModel.FirstOrDefault();
                Field field = null;
                if (ViewModel.FirstOrDefault().Fields[i].Name == "BookMark")
                {
                    field = new Field();
                    field.Name = "Bookmark";
                    field.Label = "";
                    field.BindingType = BindingType.UseAlternateBinding;

                    field.Settings = new FieldSettings();
                    field.Settings.AllowRecordFiltering = false;
                    field.Settings.Width = new FieldLength(30, FieldLengthUnitType.Pixel);
                    //Binding bnd = new Binding(string.Format("Fields[{0}].Value", i)) { Converter = new BooleanToVisibilityConverter(), Mode = BindingMode.TwoWay };
                    //BindingOperations.SetBinding(field, Field.VisibilityProperty, bnd);
                    field.AlternateBinding = new Binding(string.Format("Fields[{0}].Value", i));
                    field.CellValuePresenterStyle = this.FindResource("BookmarkCellValuePresentorStyle") as Style;

                }
                else if (ViewModel.FirstOrDefault().Fields[i].Name == "ActiveCall")
                {

                    field = new Field();
                    field.Name = "ActiveCall";
                    field.BindingType = BindingType.UseAlternateBinding;
                    field.Label = "";
                    field.Settings = new FieldSettings();
                    field.Settings.AllowRecordFiltering = false;
                    field.Settings.Width = new FieldLength(30, FieldLengthUnitType.Pixel);
                    //Binding bnd = new Binding(string.Format("Fields[{0}].Value", i)) { Converter = new BooleanToVisibilityConverter(), Mode = BindingMode.TwoWay };
                    //BindingOperations.SetBinding(field, Field.VisibilityProperty, bnd);
                    field.AlternateBinding = new Binding(string.Format("Fields[{0}].Value", i));
                    field.CellValuePresenterStyle = this.FindResource("ActiveCallCellValuePresentorStyle") as Style;

                }
                else
                {
                    field = new TextField();

                    field.Name = ViewModel.FirstOrDefault().Fields[i].Name;
                  
                    field.AlternateBinding = new Binding(string.Format("Fields[{0}].Value", i));
                }


                layout.Fields.Add(field);


            }
        }

        private void CallListGrid_RecordsInViewChanged(object sender, Infragistics.Windows.DataPresenter.Events.RecordsInViewChangedEventArgs e)
        {

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var result = this.CallListGrid.SelectedItems as Infragistics.Windows.DataPresenter.DataPresenterBase.SelectedItemHolder;

            for (int i = 0; i < result.Count(); i++)
            {
                var field = result.Records[i] as DataRecord;
                var item = field.DataItem as FieldItemMetadataCollection;
                item.Fields.Where(x => x.Name == "BookMark").FirstOrDefault().Value = true.ToString();
                item.Fields.Where(x => x.Name == "Interviewer").FirstOrDefault().Value = "changed";
            }
        }
    }
}
